<script lang="ts" setup>
import { globalData } from '~/data';


const emit = defineEmits(['authenticated'])

const username = ref('');
const email = ref('');
const password = ref('');

const register = async (e: Event) => {
  const payload = {
    username: username.value,
    email: email.value,
    password: password.value
  }
  console.log(JSON.stringify(payload));

  try {
    const data = await fetch('https://webrtc-nest.onrender.com/auth/register', {
      method: 'POST',
      body: JSON.stringify(payload),
      headers: {
        "Content-type": "application/json; charset=UTF-8"
      }
    })
    if (data.ok) {
      const json = await data.json();
      console.log(json);   
      globalData.key = json['access_token']
    }
    emit('authenticated');
  } catch (e) {
    console.error(e);
  }
  
}

const login = async () => {
  const payload = {
    email: email.value,
    password: password.value,
  }

  try {
    const data = await fetch('https://webrtc-nest.onrender.com/auth/login', {
      method: 'POST',
      body: JSON.stringify(payload),
      headers: {
        "Content-type": "application/json; charset=UTF-8"
      }
    })
    if (data.ok) {
      const json = await data.json();
      console.log(json);
      
      globalData.key = json['access_token']
      console.log(globalData.key);
      emit('authenticated');
    }
    
  } catch (e) {
    console.error(e);
  }

}
</script>

<template>
  <div class="container">
    <form>
      <div class="input-container">
        <label for="username">Username</label>
        <input v-model="username" type="text" name="username" id="username">
      </div>
      <div class="input-container">
        <label for="email">email</label>
        <input v-model="email" type="email" name="email" id="email">
      </div>
      <div class="input-container">
        <label for="password">password</label>
        <input v-model="password" type="password" name="password" id="password">
      </div>
      <div class="button-container">
        <button @click.prevent="login">LOGIN</button>
        <button @click.prevent="register">CREATE ACOUNT</button>
      </div>
    </form>
  </div>
</template>

<style>
.container {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100vh;
  overflow: hidden;
}

.input-container {
  display: flex;
  flex-direction: column;
}

form {
  border: 2px white solid;
  border-radius: 8px;
  display: flex;
  flex-direction: column;
  padding: 1rem;
  justify-content: space-between;
  gap: 1rem;
  min-width: fit-content;
}

.button-container {
  display: grid;
  grid-template-columns: repeat(2, 1fr);
  gap: 1rem;
}

button {
  all: unset;
  background-color: blue;
  padding: 1rem;
  text-align: center;
  border-radius: 8px;
}

button:hover {
  cursor: pointer;
}

input {
  all: unset;
  font-size: large;
  max-width: 100%;
  border: 1px white solid;
  padding: .5rem;
  border-radius: 8px;
}
</style>